<template>
  <v-container>
    <v-card>
      <v-card-title class="headline">EMT Checkout Page</v-card-title>
      <v-card-text>
        <!-- Patient Information Form -->
      </v-card-text>
    </v-card>
    <v-card flat tile>
            <v-card-text>

                <v-alert
                  density="compact"
                  :text="notification"
                  title="Alert title"
                  :type="actionClass"
                  v-if="notification"
                >
                {{  notification  }}

            </v-alert>
            </v-card-text>
          </v-card>
    <v-card>
      <v-card-title class="headline">Medical Supplies</v-card-title>
      <v-card-text width="10%">
        <v-row>
            <v-col cols="12" sm="6">
              <v-text-field
            dense
            outlined
            persistent-hint
            class="body-2"
            label="Patient Name"
            v-model="patientName"
            required
          ></v-text-field>
          <v-text-field
            dense
            outlined
            persistent-hint
            class="body-2"
            label="Patient Condition"
            v-model="patientCondition"
            required
          ></v-text-field>
            </v-col>
            <v-col cols="12">
              <!-- <v-textarea v-model="patientCondition" label="Condition"></v-textarea> -->
            </v-col>
          </v-row>

      </v-card-text>
      <v-card-text v-if="medicalSupplies">

        <v-data-table :headers="tableHeaders" :items="medicalSupplies" :items-per-page="5" class="elevation-1">
          <template v-slot:top>
            <v-toolbar flat>
              <v-toolbar-title>Medical Supplies</v-toolbar-title>
            </v-toolbar>
          </template>
          <template v-slot:item="{ item }">
            <tr>
              <td>{{ item.name }}</td>
              <td>{{ '$' + item.price }}</td>
              <td>{{ item.quantity }}</td>
              <td>
                <v-text-field v-model="quantityRequested[item.id]" label="Enter Quantity" type="number" required></v-text-field>
                <v-alert v-if="requestedQuantityExceedsAvailable(item.id)" type="error" dense outlined>
                  The requested quantity exceeds the available quantity.
                </v-alert>
              </td>
              <td>
                <v-btn @click="addToCart(item)" color="primary" :disabled="!quantityRequested[item.id] || requestedQuantityExceedsAvailable(item.id)">
                  Add to Cart
                </v-btn>
              </td>
            </tr>
          </template>
        </v-data-table>
      </v-card-text>
    </v-card>

    <v-dialog v-model="dialog" max-width="400">
      <v-card>
        <v-card-title class="headline">Alert</v-card-title>
        <v-card-text>
          The requested quantity exceeds the available quantity. Please enter a valid quantity.
        </v-card-text>
        <v-card-actions>
          <v-btn color="primary" @click="dialog = false">OK</v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>

    <v-card>
      <v-card-title class="headline">Order Summary</v-card-title>
      <v-card-text>
        <v-list>
          <v-list-item v-for="item in cart" :key="item.id">
            <v-list-item-content>
              <v-list-item-title>{{ item.name }}</v-list-item-title>
              <v-list-item-subtitle>${{ item.price }}</v-list-item-subtitle>
              <v-list-item-subtitle>Quantity: {{ item.quantityRequested }}</v-list-item-subtitle>
            </v-list-item-content>
          </v-list-item>
        </v-list>
      </v-card-text>
      <v-btn color="primary" type="submit" @click="submitOrder">Submit Order</v-btn>

    </v-card>
  </v-container>
</template>

<script>
import { mapMutations, mapGetters, mapState, mapActions } from 'vuex';

export default {
  data() {
    return {
      patientName: '',
      patientCondition: '',
      inventory: null,
      medicalSupplies: null,
      quantityRequested: {},
      cart: [],
      dialog: false,
      notification: null,
      actionClass: null,
      tableHeaders: [
        { text: 'Name', value: 'name' },
        { text: 'Price', value: 'price' },
        { text: 'Quantity', value: 'quantity' },
        { text: 'Enter Quantity', value: 'quantityRequested' },
        { text: 'Actions', value: 'actions', sortable: false },
      ],
    };
  },
  async mounted() {
    await this.retrieveInventory();
  },
  computed: {
    totalPrice() {
      return this.cart.reduce((total, item) => total + (item.quantity * item.price), 0);
    },
  },
  methods: {
    ...mapActions(['axiosGetRequest', 'axiosPostRequest']),

    addToCart(item) {
      const requestedQuantity = this.quantityRequested[item.id];
      if (requestedQuantity <= 0 || requestedQuantity > item.quantity) {
        this.dialog = true;
        return;
      }
      const cartItem = { ...item, quantityRequested: requestedQuantity, product_id: item.id };
      this.cart.push(cartItem);
      this.quantityRequested[item.id] = null;
    },
    async retrieveInventory() {
      this.loading = true;
      this.inventory = null;
      this.medicalSupplies = null;

      const payload = {};
      // const endpoint = `FAQs/active`;

      const fullPayload = {
        app: process.env.VUE_APP_ROOT_API,
        params: payload,
        endpoint: '/inventory',
      };

      try {
        const response = await this.axiosGetRequest(fullPayload);
        this.inventory = response.status === 200 ? response.data : null;
        // console.log('inventory', response.data);
        this.medicalSupplies = this.inventory;
        this.loading = false;

        return response;
      } catch (error) {
        this.loading = false;
        return null;
      }
    },
    async submitOrder() {
      const orderData = {
        customer_name: this.patientName,
        total_price: this.totalPrice,
        orderItems: this.cart,
      };

      const fullPayload = {
        params: orderData,
        endpoint: '/checkout',
      };

      try {
        const res = await this.axiosPostRequest(fullPayload);
        this.notification = res.status === 200 ? 'Checkout successful' : res.data.message;

        this.actionClass = res.status === 200 || res.status === 201 ? 'success' : 'error';
      } catch (error) {
        this.notification = 'Checkout failed. Contact the admin';
        this.actionClass = 'error';
        return error.response;
      }
    },
    requestedQuantityExceedsAvailable(itemId) {
      return this.quantityRequested[itemId] > this.medicalSupplies.find(item => item.id === itemId).quantity;
    },
  },
};
</script>

<style scoped>
/* Add custom styles here */
</style>
